from django.contrib.syndication.feeds import Feed
from django.utils.feedgenerator import Atom1Feed
from django.core.exceptions import ObjectDoesNotExist

from project.forager.models import MusicRelease
import project.forager.settings as cfg


class MBReleases(Feed):
	feed_type = Atom1Feed

	title = cfg.feed_title
	link = cfg.feed_link
	description = cfg.feed_desc

	def get_object(self, req):
		req = filter(None, req)
		if not req: req = 50
		elif len(req) > 1: raise ObjectDoesNotExist
		else:
			try: req = int(req[0])
			except ValueError: raise ObjectDoesNotExist
		rel = MusicRelease.objects.all()[:req]
		return rel

	def items(self, items): return items
	def item_description(self, item): return item.summary
